'''
$Id: User.py,v 1.5 1999/11/17 07:23:37 zen Exp $
'''

import Globals, App.Undo

from string import split,join
from base64 import decodestring, encodestring
from urllib import quote, unquote
from AccessControl.User import BasicUser, BasicUserFolder, \
    _remote_user_mode, domainSpecMatch
from AccessControl.PermissionRole import _what_not_even_god_should_do
import types
import whrandom
from zLOG import LOG

from time import time
import sha

#def _debug(msg): pass
#def _debug(msg): LOG('GUF',0,msg)

class User(BasicUser):
    
    icon='misc_/GenericUserFolder/User_icon'  # Hmm....

    def __init__(self, name, guf):
	self.name   =name
	self._guf = guf
	self._getRolesRecurse = 0
	self._exptime = time()
	self._rolecache = None
	self._domaincache = None
	self.__ = None

    def getUserName(self):
        return self.name

    def _expire(self):
	t = time()
	guf = self._guf
	if t > self._exptime + guf.user_expires:
	    self._rolecache = None
	    self._domaincache = None
	    self.__ = None
	    self._exptime = t + guf.user_expires
	    return 1
	return 0

    def getRoles(self):
	'''Return a list of roles this user belongs to'''
	self._expire()

	if self._rolecache is not None: 
	    return self._rolecache

	# If our userRoles method needs to access another method,
	# Zope will call this again, so we need to detect this to
	# avoid infinite recursion and core dump. Returns a dummy
	# role. In this special case, you need to assign a proxy
	# role to the userRoles method so *it* has the required rights,
	# as since we have no authenticated user yet, there is nowhere else
	# to get the rights from. The alternative is to allow anonymous
	# access to the second method, which is not a good thing to
	# do with your security subsystem :-)
	if self._getRolesRecurse:
	    return ['Anonymous',]
	self._getRolesRecurse = 1

	if hasattr(self._guf,'userRoles'):
	    data = self._guf.userRoles(self._guf,
		self._guf.REQUEST, username=self.name)
	    if type(data) == types.StringType:
		data = split(data)
	    else:
		data = list(data)

		if len(data) > 0 and type(data[0] != types.StringType):
		    if hasattr(data[0],'role'):
			for i in range(0,len(data)):
			    data[i] = data[i].role
		    elif hasattr(data[0],'r'):
			for i in range(0,len(data)):
			    data[i] = data[i].r

		    if type(data[0] != types.StringType):
			raise 'Unsupported Type',\
			    'userRoles returned an unsupported type'

	    if 'Anonymous' not in data:
		data.insert(0,'Anonymous')
		data.sort()

	    #data = tuple(data) # Faster access? NFI

	    self._rolecache = data
	    return data

	else:
	    LOG('GUF',100,'No userRoles method available')
	    return ['Anonymous',]
    
    def getDomains(self):
	'''Return a list of domains this user can log in from'''
	self._expire()

	if self._domaincache is not None: 
	    return self._domaincache

	if hasattr(self._guf,'userDomains'):
	    data = self._guf.userDomains(
		self._guf, self._guf.REQUEST,
		username=self.getUserName())

	    if type(data) == types.StringType:
		data = split(data)
	    else:
		data = list(data)

		if len(data) > 0 and type(data[0] != types.StringType):
		    if hasattr(data[0],'domain'):
			for i in range(0,len(data)):
			    data[i] = data[i].domain
		    elif hasattr(data[0],'d'):
			for i in range(0,len(data)):
			    data[i] = data[i].domain

		    if type(data[0] != types.StringType):
			raise 'Unsupported Type',\
			    'userDomains returned an unsupported type'

	    if data and not self._guf.domainSpecValidate(data):
		raise 'Illegal domain spec (%s) for %s' \
		    % (str(data),self.getUserName())
	    self._domaincache = data
	    return data
	self._domaincache = []
	return self._domaincache

    def authenticate(self, password, request):
	'''Authenticate a user'''

	self._expire()

	#_debug('Authenticating user %s' % self.getUserName())

	if not hasattr(self._guf,'userAuthenticate'):
	    LOG('GUF',100,'No userAuthenticate method - %s auth failed' \
		% getUserName())
	    return 0

	# Don't even bother checking password if we are from a dud
	# domain
	domains=self.getDomains()
	if domains and not domainSpecMatch(domains,request):
	    return 0

	# If we have a cached hash, we can shortcut
	# Don't bother logging, as we have already logged success
	# and we don't want too much spam
	if self.__ is not None:
	    return self.__ == sha.new(password).digest()

	if self._guf.userAuthenticate(self._guf, request,
			username=self.getUserName(), password=password):
	    # Log a message - this might spam if not using cookie
	    # authentication? Is tune your logs a good response? I don't
	    # want a toggle to turn this off via the web as it could ease
	    # security breaches
	    LOG('GUF',0,'Successful authentication for user %s (%s)' \
		% (self.getUserName(),self._guf.absolute_url()))
	    self.__ = sha.new(password).digest() # Cache the hash only
	    return 1

	# Note we can't log failed authentication atempts here due to the
	# 'stacked' nature of Zope's UserFolders.
	return 0


